//AXI lite Write (Redpitaya side)

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#define RP_OK 0;
#define RP_EMMD 1;
#define RP_EUMD 1;
#define RP_ECMD 1;
#define RP_EOMD 1;

static int fd = 0;

int Init()
{
    if (!fd) {
        if((fd = open("/dev/mem", O_RDWR | O_SYNC)) == -1) { return RP_EOMD; }
    }
    return RP_OK;
}

int Release()
{
    if (fd) {
        if(close(fd) < 0) {
            return RP_ECMD;
        }
    }
    return RP_OK;
}

void * Map(size_t size, size_t offset)
{
    static void* mapaddr = NULL;
    if(fd == -1) { return NULL; }
    if(!mapaddr)
	mapaddr = mmap(NULL, size, PROT_READ | PROT_WRITE, MAP_SHARED, fd, offset);
    if(!mapaddr) { return NULL; }
    return mapaddr;
}

int main(int argc, char **argv) {
 printf("Axi write test \n");

 if(argc<3) {
  printf("usage: %s address size [d1 d2 ... ]\n",argv[0]);
  return 1;
 }

 size_t map_addr = strtol(argv[1],NULL,16);
 size_t map_size = atoi(argv[2]);
 int i;
 printf("writing on address %d with size %d\n",map_addr,map_size);
// int data[20];
// for(i=3; i<argc; ++i) {
//     data[i-3] = atoi(argv[i]);
// }

 Init();
 int *addr = Map(map_size, map_addr);

 for(i=0; i<argc-3; ++i) {
     *(addr+i) = atoi(argv[i+3]);
 }
 for(i=0; i<argc-3; ++i) {
     printf("data[%d] = %d\n",i,*(addr+i));
 }


 Release();
 return 0;
}



